/*
'Magick' configuration file parser, can be used to fill directly the structure that will be used by the program

*/

/*
#if SIZEOF(void *) != SIZEOF(long)
error!!! sizeof(void *) != sizeof(long)!!!  this will cause trouble
#endif*/
enum entrytype {
  TYPE_STRING=1,
  TYPE_INTEGER,
  TYPE_BOOLEAN,
  TYPE_CUSTOM
};
struct configentry 
{
  char * key;
  enum entrytype type;
  char * customtype; //a format string useable by *scanf functions
  long multiple; //if true, value is filled with a ptr to a multiplevalues struct, otherwise the value is filled in directly
  long maxstringsize; //maximum size of a string (in case of a "%s" element in custom format)
};

struct multiplevalues
{
  long count;   //number of results, the size of a result is determined by customtype if it is a custom type
  long allocated; //allocated size of values
  void ** values;
};

/*
VALUES must be allocated, if VALUES|i] is a multipleentries, it must be either allocated and valid, or NULL 
*/
unsigned int parseconfig(char * filename, struct configentry *entries, void** values);

unsigned int fillconfig(char * filename, struct configentry *entries, void** values);
